Attribute VB_Name = "MidiLib"
'Written by David Finch
Option Explicit
DefLng A-Z

Public Declare Function midiOutOpen Lib "winmm.dll" (lphMidiOut As Long, ByVal uDeviceID As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Public Declare Function midiOutClose Lib "winmm.dll" (ByVal hMidiOut As Long) As Long
Public Declare Function midiOutShortMsg Lib "winmm.dll" (ByVal hMidiOut As Long, ByVal dwMsg As Long) As Long


'#define NoteOnCmd       0x90
'#define NoteOffCmd      0x80
'#define PgmChngCmd      0xC0
'#define ControlCmd      0xB0
'#define PolyPressCmd    0xA0
'#define ChanPressCmd    0xD0
'#define PchWheelCmd     0xE0
'#define SysExCmd        0xF0

Private mdh As Long
Private midiOpened As Boolean

Public Sub MidiOpen()
    If midiOutOpen(mdh, 0, 0, 0, 0) Then
        On Error Resume Next
        Open App.path + "\folders\temporary\pmidi.tmp" For Input As #4
        If Err.Number = 0 Then
            Dim i As Long
            Dim s As String
            Line Input #4, s
            Input #4, i
            midiOutClose i
            Close #4
        End If
        If midiOutOpen(mdh, 0, 0, 0, 0) Then
            Exit Sub
        End If
    End If
    'allows for closing midi after a crash
    Open App.path + "\folders\temporary\pmidi.tmp" For Output As #4
    Print #4, "Previous midi handle: (used in case it crashed last time)"
    Print #4, mdh
    Close #4
    midiOpened = True
End Sub

Public Sub MidiClose()
    If midiOpened Then
        midiOutClose mdh
        midiOpened = False
    End If
End Sub

Public Sub SelectInstrument(ByVal channel As Long, ByVal patch As Long)
    If midiOpened Then midiOutShortMsg mdh, &HC0 Or patch * 256 Or channel
End Sub

Public Sub ToneOn(ByVal channel As Long, ByVal tone As Long, ByVal volume As Long)
    If midiOpened Then
        If tone < 0 Then tone = 0
        If tone > 127 Then tone = 127
        volume = EmuVolPUB
        midiOutShortMsg mdh, &H90 Or tone * 256 Or channel Or volume * 65536
    End If
End Sub

Public Sub ToneOff(ByVal channel As Long, ByVal tone As Long)
    If midiOpened Then
        If tone < 0 Then tone = 0
        If tone > 127 Then tone = 127
        midiOutShortMsg mdh, &H80 Or tone * 256 Or channel
    End If
End Sub

Public Function fixhex(f As String) As String
  If Len(f$) = 1 Then
    fixhex$ = "0" & f$
  Else
    fixhex$ = f$
  End If
End Function
