Attribute VB_Name = "mapper19"
Option Explicit

Public Sub map19_irq()
  If MIRQOn = 1 Then
    MMC19_IRQCount = MMC19_IRQCount + 1
    If MMC19_IRQCount = &H7FFF& Then
      Call irq6502
    End If
  End If
End Sub

Public Sub map19_write(address As Long, value As Byte)
  Select Case address
    Case &H5000& To &H57FF&
      tmpLatch = value
    Case &H5800& To &H5FFF&
      If value And &H80 Then
        MIRQOn = 1
      Else
        MIRQOn = 0
      End If
      MMC19_IRQCount = ((value And &H7F) * &H100&) + tmpLatch
    Case &H8000& To &H87FF&
      Call Select1KVROM(value, 0)
    Case &H8800& To &H8FFF&
      Call Select1KVROM(value, 1)
    Case &H9000& To &H97FF&
      Call Select1KVROM(value, 2)
    Case &H9800& To &H9FFF&
      Call Select1KVROM(value, 3)
    Case &HA000& To &HA7FF&
      Call Select1KVROM(value, 4)
    Case &HA800& To &HAFFF&
      Call Select1KVROM(value, 5)
    Case &HB000& To &HB7FF&
      Call Select1KVROM(value, 6)
    Case &HB800& To &HBFFF&
      Call Select1KVROM(value, 7)
    Case &HC000& To &HC7FF&
      If value < &HE0 Then
        Call Select1KVROM(value, 8)
      End If
    Case &HC800& To &HC8FF&
      If value < &HE0 Then
        Call Select1KVROM(value, 9)
      End If
    Case &HD000& To &HD7FF&
      If value < &HE0 Then
        Call Select1KVROM(value, 10)
      End If
    Case &HD800& To &HD8FF&
      If value < &HE0 Then
        Call Select1KVROM(value, 11)
      End If
    Case &HE000& To &HE7FF&
      reg8 = value
      Call SetupBanks
    Case &HE800& To &HEFFF&
      regA = value
      Call SetupBanks
    Case &HF000& To &HF7FF&
      regC = value
      Call SetupBanks
  End Select
End Sub

